<script lang="ts">
	import type { Message } from "$lib/types";
	import { createEventDispatcher } from "svelte";

	const dispatch = createEventDispatcher<{
		send: string;
	}>();

	export let history: Message[] = [];
	export let compose: string = "";

	function send() {
		dispatch("send", compose);
		compose = "";
	}

	function onEnter(e: KeyboardEvent) {
		if (e.key === "Enter") {
			e.preventDefault();
			send();
		}
	}
</script>

<ol>
	{#each history as message, i}
		<li>
			{#if i === 0 || history[i - 1].author !== message.author}
				<strong>{message.author}:</strong>
			{/if}
			{message.body}
		</li>
	{/each}
</ol>
<input bind:value={compose} on:keypress={onEnter}>
<button on:click={send}>Send</button>

<style>
	ol {
		list-style-type: none;
		padding: 0;
	}
</style>
